import Foundation
import UIKit
import Family

class HeaderViewController: UIViewController {
    override func viewDidLoad() {
        super.viewDidLoad()

        let containerView = UIView()
        containerView.translatesAutoresizingMaskIntoConstraints = false
        containerView.backgroundColor = .gray

        let subview = UIView()
        subview.backgroundColor = .red
        subview.translatesAutoresizingMaskIntoConstraints = false
        containerView.addSubview(subview)

        subview.topAnchor.constraint(equalTo: containerView.topAnchor).isActive = true
        subview.leadingAnchor.constraint(equalTo: containerView.leadingAnchor).isActive = true
        subview.trailingAnchor.constraint(equalTo: containerView.trailingAnchor).isActive = true
        subview.bottomAnchor.constraint(equalTo: containerView.bottomAnchor).isActive = true
        #warning("This constraints is removed as impossible to statisfies")
        subview.heightAnchor.constraint(equalToConstant: 200).isActive = true
        self.view.addSubview(containerView)

        containerView.trailingAnchor.constraint(equalTo: view.trailingAnchor).isActive = true
        containerView.leadingAnchor.constraint(equalTo: view.leadingAnchor).isActive = true
        containerView.topAnchor.constraint(equalTo: view.topAnchor).isActive = true
        containerView.bottomAnchor.constraint(equalTo: view.bottomAnchor).isActive = true
    }
}

class ListCell: UITableViewCell {
    override init(style: UITableViewCell.CellStyle, reuseIdentifier: String?) {
        super.init(style: style, reuseIdentifier: reuseIdentifier)

        print("INIT CELL")
    }

    required init?(coder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    override func prepareForReuse() {
        super.prepareForReuse()
    }
}

class ListViewController: UITableViewController {
    override func viewDidLoad() {
        super.viewDidLoad()

        tableView.rowHeight = 50.0
        tableView.register(ListCell.self, forCellReuseIdentifier: "ListCell")
    }

    override func numberOfSections(in tableView: UITableView) -> Int {
        return 1
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return 200
    }

    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "ListCell", for: indexPath) as! ListCell
        cell.textLabel?.text = "\(indexPath.row) item"

        return cell
    }
}

class MyViewController: FamilyViewController {
    override func viewDidLoad() {
        super.viewDidLoad()

        let listVC = ListViewController(style: .plain)
        let headerVC = HeaderViewController()

        addChild(headerVC)
        addChild(listVC)
    }
}
